% Eingabe der Regelungsparameter
% 'Hier Eingabe ReDuS_P', modellbasierte Entkopplung und Linearisierung
% und ReDuS-P-Kaskade, es wird die Zeitkonstante TG des virtuellen Geschw. RK angegeben
% Eingabe der Regelungsparameter

TA=T_Ipo; % hier wird vorlufig im T_ipo Takt geregelt

TG1=input('Zeitkonstante des virtuellen P-T1 Geschw. RK, Gelenk 1: ');
TG2=input('Zeitkonstante des virtuellen P-T1 Geschw. RK, Gelenk 2: ');

KP1=1/TG1;
KP2=1/TG2;

TR1=input('Zeitkonstante des virtuellen P-T2 Lageregelkreises, Gelenk 1: ');
TR2=input('Zeitkonstante des virtuellen P-T2 Lageregelkreises, Gelenk 2: ');

dR1=input('Dmpfungskonstante des virtuellen P-T2 Lageregelkreises, Gelenk 1: ');
dR2=input('Dmpfungskonstante des virtuellen P-T2 Lageregelkreises, Gelenk 2: ');

% Es gilt:
a0_1=0; a1_1=1; a2_1=TG1;
a0_2=0; a1_2=1; a2_2=TG2;

beta1= a2_1/TR1^2;
beta2= a2_2/TR2^2;

KI1=(a1_1-2*dR1*TR1*beta1)/TR1^2;
KI2=(a1_2-2*dR2*TR2*beta2)/TR2^2;

alpha1=2*dR1*TR1*KI1+beta1-a0_1;
alpha2=2*dR2*TR2*KI2+beta2-a0_2;



KP=[KP1 ;  KP2]; 

alpha=[alpha1  ;   alpha2]; 
beta=[beta1  ;  beta2]; 
KI=[KI1  ;  KI2];