% Regelalgorithmus P-PI-Kaskade, dezentrale Regelung 
% Es gilt fr den Lageregler:
% vs=KL*e+Kvor*qpsoll, es wird mit Matrizen/Vektoren gerechnet
function [US, ev]=P_PI(KL, KVor, c1, c2, ev_alt,US_alt, US_limit, qsoll_akt, qist_akt, qpsoll_akt, qpist_akt);
e=qsoll_akt- qist_akt;
vs=KL .* e+ KVor .* qpsoll_akt;
ev=vs-qpist_akt;
US=US_alt+c1 .* ev-c2 .* ev_alt;
for l1=1:2
if abs(US(l1,1)) > US_limit(l1,1)
    US(l1,1)=sign(US(l1,1))*US_limit(l1,1);
end
end

