% Pruefung, ob Start- und Zielpunkt im Arbeitsraum (Halbkreisscheibe) oder bei einer Linearbahn 
% die Gerade zwischen Startpunkt und Zielpunkt nicht im Arbeitsraum liegt
% (nicht fahrbar --> bahnvorgabe=0, fahrbar: bahnvorgabe=1 )
% W. Weber, Oktober 2012, nderungen Mai 2020

bahnvorgabe =1;  % Startwert 

% Zuerst wird sowohl fr PTP als auch Linearbahn geprft, ob Start- und
% Zielpunkt im Arbeitsbereich liegen

% es gilt. a2=l2 (Lnge des 2. Armteils)

entsch_1=(p_St(3,1) < (q1_min - a2) | p_St(3,1) > (q1_max+a2) | ...
    p_St(1,1) <0 | p_St(1,1)> a2);

entsch_2=(p_Z(3,1) < (q1_min - a2) | p_Z(3,1) > (q1_max+a2) | ...
    p_Z(1,1) <0 | p_Z(1,1)> a2);

zw1_pruef_St=p_St(3,1)< q1_min & (p_St(3,1)-q1_min)^2+p_St(1,1)^2 > a2^2;
zw2_pruef_St=p_St(3,1) > q1_max & (p_St(3,1)-q1_max)^2+p_St(1,1)^2 > a2^2;
entsch_1a=( zw1_pruef_St | zw2_pruef_St);
 
zw1_pruef_Z=p_Z(3,1)< q1_min & (p_Z(3,1)-q1_min)^2+p_Z(1,1)^2 > a2^2;
zw2_pruef_Z=p_Z(3,1) > q1_max & (p_Z(3,1)-q1_max)^2+p_Z(1,1)^2 > a2^2;

entsch_2a=(zw1_pruef_Z | zw2_pruef_Z);
   

if entsch_1 ==1 | entsch_1a ==1
    disp('Startpunkt nicht im Bewegungsbereich')
    disp('Bitte Neueingabe!') 
    bahnvorgabe =0;
end
if entsch_2==1 | entsch_2a ==1
    disp('Zielpunkt nicht im Bewegungsbereich')
    disp('Bitte Neueingabe!') 
    bahnvorgabe =0;
end
 

    