% Test, erster berechneter wert von px, pz, ppx, ppz
px =   0.499987692307692
pz=   0.100029538461538

ppx=-0.006153846153846
ppz=0.014769230769231

T_Ipo=0.002
a2=0.5

q_alt=[0.1;3.141592653589793]
q1_min=0
q1_max=1.5
q2_min=pi/2
q2_max=1.5*pi

q_bereich=abs([q1_max;q2_max]-[q1_min;q2_min])

% Mitte des Bewegungsbereiches
q_mitte=[q1_min;q2_min]+q_bereich/2


% RTRAFO
q2a=acos(-px/a2);
q2b=- q2a;


 
    % Es folgt die Abbildung des Winkels q2 in den numerisch angegebenen
    % Bewegungsbereich: bsp: q2=-230° --> q2b=130°
    if q2a > q2_max |  q2a< q2_min
        q2a=q2a-sign(q2a)*2*pi; % Abbildung, wenn möglich, in die num. Angabe des Bewegungsbereich 
    end
       
     if q2b > q2_max |  q2b< q2_min
        q2b=q2b-sign(q2b)*2*pi;
     end
    
    q1a=pz-a2*sin(q2a);
    q1b=pz-a2*sin(q2b);
   
    % Prüfung, ob im Bewegungsbereich und Abstand zur alten Lösung
    if (q1a <= q1_max & q1a >= q1_min) & ...
         (q2a <= q2_max & q2a >= q2_min)   
        loes_a=1;
        %ja=norm(q_veka(:,i1)-q_vek(:,i1-1));
        %ja=norm([q1a;q2a]-q_mitte);
        ja=norm([q1a;q2a]-q_alt);
    else 
        loes_a=0;
        ja=123000000000;
    end
    if (q1b <= q1_max & q1b >= q1_min) & ...
         (q2b <= q2_max & q2b >= q2_min)   
        loes_b=1;
        %q_alt=q_vek(:,i1-1)
        %jb=norm(q_vekb(:,i1)-q_vek(:,i1-1));
        %jb=norm([q1b;q2b]-q_mitte)
        jb=norm([q1b;q2b]-q_alt)
    else 
        loes_b=0;
        jb=12300000000000;
    end
    % Auswahl der Lösung
    if loes_a==1 & loes_b==1
        if ja<=jb
        q1=q1a;
        q2=q2a;
        else
        q1=q1b;
        q2=q2b;
        end
    end
    if loes_a==1 & loes_b==0
        q1=q1a;
        q2=q2a;
    elseif  loes_a==0 & loes_b==1 
        q1=q1b;
        q2=q2b;
    elseif loes_a==0 & loes_b==0
        ' keine Lösung!!!????'
        return
    end
    
    disp('Lösung des RTRAFO')
    q1
    q2
  
 % Berechnung qp
 eps_sing=0.0001
 qp_alt=[0;0];
    


       if abs(sin(q2)) < eps_sing
      disp('singuläre Stellung')
      
        qp1= (q1-q_alt(1,1))/(T_Ipo)
        qp2=(q2-q_alt(2,1))/(T_Ipo)
     
       else
   
        disp('keine singuläre Stelle')
        qp1=(-1/tan(q2)) * ppx + ppz;
        qp2=1/(a2*sin(q2))* ppx
        %qp_vek(2,i1)=1/(a2*cos(q_vek(2,i1)-pi/2))* p_punkt_vek(1,i1);       % diese Lösung bis 1.9.23
        %qp_vek(1,i1)=sin(q_vek(2,i1)-pi/2) * a2*qp_vek(2,i1) + p_punkt_vek(3,i1); % diese Lösung bis 1.2.23
    
       end

% tEST DURCH JACOBIMATRIX
ppx_test=a2*sin(q2)*qp2
ppz_test=qp1+a2*cos(q2)*qp2

disp('ppx-ppx_test, ppz-ppz_test')
diffp_1=ppx-ppx_test
diffp_2=ppz-ppz_test

%test_singulaer(1,:)=abs(cos(q_vek(2,:)-pi/2))
%abs(cos(q_vek(2,:)-pi/2)) > eps_sing 
%qp_vek(1,:)=tan(q_vek(2,:)-pi/2) .* p_punkt_vek(1,:) + p_punkt_vek(3,:);
%qp_vek(2,:)=1./(a2*cos(q_vek(2,:)-pi/2)).* p_punkt_vek(1,:);

