% Regelalgorithmus des modellbasierten Reglers zur Einprgung eines PT2-Verhaltens
% Es gilt fr den Lageregler:
% US=M_Stern * r0 + b_Stern
function [US]=Mod_PT2(A0, A1, US_alt,US_limit, qsoll_akt, qist_akt, qpsoll_akt, qpist_akt);
e=qsoll_akt- qist_akt;
r0=A0*e-A1*qpist_akt;
[US]=InversesModell_TR(qist_akt,qpist_akt,r0,US_alt);
for l1=1:2
if abs(US(l1,1)) > US_limit(l1,1)
    US(l1,1)=US_limit(l1,1)*sign(US(l1,1))
end
end
